///
/// HybridImagePerspectiveCropperSpec.swift
/// This file was generated by nitrogen. DO NOT MODIFY THIS FILE.
/// https://github.com/mrousavy/nitro
/// Copyright © 2024 Marc Rousavy @ Margelo
///

import Foundation
import NitroModules

/**
 * A Swift protocol representing the ImagePerspectiveCropper HybridObject.
 * Implement this protocol to create Swift-based instances of ImagePerspectiveCropper.
 *
 * When implementing this protocol, make sure to initialize `hybridContext` - example:
 * ```
 * public class HybridImagePerspectiveCropper : HybridImagePerspectiveCropperSpec {
 *   // Initialize HybridContext
 *   var hybridContext = margelo.nitro.HybridContext()
 *
 *   // Return size of the instance to inform JS GC about memory pressure
 *   var memorySize: Int {
 *     return getSizeOf(self)
 *   }
 *
 *   // ...
 * }
 * ```
 */
public protocol HybridImagePerspectiveCropperSpec: AnyObject, HybridObjectSpec {
  // Properties
  

  // Methods
  func detectRectangleForImage(image: String, onSuccess: @escaping ((_ rectangle: Rectangle) -> Void), onError: @escaping ((_ message: String) -> Void)) throws -> Void
  func cropImage(image: String, rectangle: Rectangle, onSuccess: @escaping ((_ image: String) -> Void), onError: @escaping ((_ message: String) -> Void)) throws -> Void
}
