///
/// HybridImagePerspectiveCropperSpecCxx.swift
/// This file was generated by nitrogen. DO NOT MODIFY THIS FILE.
/// https://github.com/mrousavy/nitro
/// Copyright © 2024 Marc Rousavy @ Margelo
///

import Foundation
import NitroModules

/**
 * Helper class for converting instances of `HybridImagePerspectiveCropperSpecCxx` from- and to unsafe pointers.
 * This is useful to pass Swift classes to C++, without having to strongly type the C++ function signature.
 * The actual Swift type can be included in the .cpp file, without having to forward-declare anything in .hpp.
 */
public final class HybridImagePerspectiveCropperSpecCxxUnsafe {
  /**
   * Casts a `HybridImagePerspectiveCropperSpecCxx` instance to a retained unsafe raw pointer.
   * This acquires one additional strong reference on the object!
   */
  public static func toUnsafe(_ instance: HybridImagePerspectiveCropperSpecCxx) -> UnsafeMutableRawPointer {
    return Unmanaged.passRetained(instance).toOpaque()
  }

  /**
   * Casts an unsafe pointer to a `HybridImagePerspectiveCropperSpecCxx`.
   * The pointer has to be a retained opaque `Unmanaged<HybridImagePerspectiveCropperSpecCxx>`.
   * This removes one strong reference from the object!
   */
  public static func fromUnsafe(_ pointer: UnsafeMutableRawPointer) -> HybridImagePerspectiveCropperSpecCxx {
    return Unmanaged<HybridImagePerspectiveCropperSpecCxx>.fromOpaque(pointer).takeRetainedValue()
  }
}

/**
 * A class implementation that bridges HybridImagePerspectiveCropperSpec over to C++.
 * In C++, we cannot use Swift protocols - so we need to wrap it in a class to make it strongly defined.
 *
 * Also, some Swift types need to be bridged with special handling:
 * - Enums need to be wrapped in Structs, otherwise they cannot be accessed bi-directionally (Swift bug: https://github.com/swiftlang/swift/issues/75330)
 * - Other HybridObjects need to be wrapped/unwrapped from the Swift TCxx wrapper
 * - Throwing methods need to be wrapped with a Result<T, Error> type, as exceptions cannot be propagated to C++
 */
public class HybridImagePerspectiveCropperSpecCxx {
  /**
   * The Swift <> C++ bridge's namespace (`margelo::nitro::customcrop::bridge::swift`)
   * from `ImagePerspectiveCropper-Swift-Cxx-Bridge.hpp`.
   * This contains specialized C++ templates, and C++ helper functions that can be accessed from Swift.
   */
  public typealias bridge = margelo.nitro.customcrop.bridge.swift

  /**
   * Holds an instance of the `HybridImagePerspectiveCropperSpec` Swift protocol.
   */
  private var __implementation: any HybridImagePerspectiveCropperSpec

  /**
   * Create a new `HybridImagePerspectiveCropperSpecCxx` that wraps the given `HybridImagePerspectiveCropperSpec`.
   * All properties and methods bridge to C++ types.
   */
  public init(_ implementation: some HybridImagePerspectiveCropperSpec) {
    self.__implementation = implementation
    /* no base class */
  }

  /**
   * Get the actual `HybridImagePerspectiveCropperSpec` instance this class wraps.
   */
  @inline(__always)
  public func getHybridImagePerspectiveCropperSpec() -> any HybridImagePerspectiveCropperSpec {
    return __implementation
  }

  /**
   * Contains a (weak) reference to the C++ HybridObject to cache it.
   */
  public var hybridContext: margelo.nitro.HybridContext {
    @inline(__always)
    get {
      return self.__implementation.hybridContext
    }
    @inline(__always)
    set {
      self.__implementation.hybridContext = newValue
    }
  }

  /**
   * Get the memory size of the Swift class (plus size of any other allocations)
   * so the JS VM can properly track it and garbage-collect the JS object if needed.
   */
  @inline(__always)
  public var memorySize: Int {
    return self.__implementation.memorySize
  }

  // Properties
  

  // Methods
  @inline(__always)
  public func detectRectangleForImage(image: std.string, onSuccess: bridge.Func_void_Rectangle, onError: bridge.Func_void_std__string) -> Void {
    do {
      try self.__implementation.detectRectangleForImage(image: String(image), onSuccess: { () -> ((Rectangle) -> Void) in
        let __sharedClosure = bridge.share_Func_void_Rectangle(onSuccess)
        return { (__rectangle: Rectangle) -> Void in
          __sharedClosure.pointee.call(__rectangle)
        }
      }(), onError: { () -> ((String) -> Void) in
        let __sharedClosure = bridge.share_Func_void_std__string(onError)
        return { (__message: String) -> Void in
          __sharedClosure.pointee.call(std.string(__message))
        }
      }())
      return 
    } catch {
      let __message = "\(error.localizedDescription)"
      fatalError("Swift errors can currently not be propagated to C++! See https://github.com/swiftlang/swift/issues/75290 (Error: \(__message))")
    }
  }
  
  @inline(__always)
  public func cropImage(image: std.string, rectangle: Rectangle, onSuccess: bridge.Func_void_std__string, onError: bridge.Func_void_std__string) -> Void {
    do {
      try self.__implementation.cropImage(image: String(image), rectangle: rectangle, onSuccess: { () -> ((String) -> Void) in
        let __sharedClosure = bridge.share_Func_void_std__string(onSuccess)
        return { (__image: String) -> Void in
          __sharedClosure.pointee.call(std.string(__image))
        }
      }(), onError: { () -> ((String) -> Void) in
        let __sharedClosure = bridge.share_Func_void_std__string(onError)
        return { (__message: String) -> Void in
          __sharedClosure.pointee.call(std.string(__message))
        }
      }())
      return 
    } catch {
      let __message = "\(error.localizedDescription)"
      fatalError("Swift errors can currently not be propagated to C++! See https://github.com/swiftlang/swift/issues/75290 (Error: \(__message))")
    }
  }
}
